#extension GL_OES_EGL_image_external : require
precision mediump float;
varying vec2 vTextureCoord;
uniform samplerExternalOES sTexture;

vec3 color_control(vec4 tc, float contrast, float brightness, float saturate) {
    vec3 color;

    // add saturation
    float grayColor = tc.r * 0.2125 + tc.g *0.7154 + tc.b * 0.0721;
    vec4 gray = vec4(vec3(grayColor), 1.0);
    vec4 ts = clamp(gray + saturate * (tc - gray), 0.0, 1.0);

    // add contrast
    color = (ts.rgb - vec3(0.5)) * contrast + vec3(0.5);

    // add brightness
    color = color.rgb + vec3(brightness);
    return color;
}


void main() {
    vec4 tc = texture2D(sTexture, vTextureCoord);

    // color control 1
    vec3 color = color_control(tc, 1.1, 0.0, 0.91);
    // blending red
    vec3 red = vec3(0.988, 0.921, 0.909);
    color = vec3(min(color.r, red.r), min(color.g, red.g), min(color.b, red.b));

    // increasing blue
    //vec3 blue = vec3(0.643, 0.972, 1.);
    color = vec3(color.r  + color.b * 0.1, color.g * 0.9 + color.b * 0.1, color.b * 1.1);

    // color control 2
    color = color_control(vec4(color, 255), 1.7, 0.0, 0.5);
    gl_FragColor = vec4(color.r, color.g, color.b, 1.0);

}