#extension GL_OES_EGL_image_external : require
precision mediump float;
varying highp vec2 vTextureCoord;
uniform lowp samplerExternalOES sTexture;
uniform highp float aspectRatio;

uniform highp vec2 center;
uniform highp float radius;
uniform highp float scale;

void main() {
    highp vec2 textureCoordinateToUse = vTextureCoord;
    highp vec2 tcoordAdjusted = vec2(vTextureCoord.x, (vTextureCoord.y * aspectRatio + 0.5 - 0.5 * aspectRatio));
    highp float dist = distance(center, tcoordAdjusted);
    textureCoordinateToUse -= center;
    if (dist < radius) {
        highp float percent = 1.0 - ((radius - dist) / radius) * scale;
        percent = percent * percent;
        textureCoordinateToUse = textureCoordinateToUse * percent;
    }
    textureCoordinateToUse += center;
    gl_FragColor = texture2D(sTexture, textureCoordinateToUse);
}