#extension GL_OES_EGL_image_external : require
#define KERNEL_SIZE 9
precision mediump float;
varying vec2 vTextureCoord;
uniform samplerExternalOES sTexture;
uniform float uKernel[KERNEL_SIZE];
uniform float uColorMixFactor;
uniform float uColorEnhance;

void main() {
   vec4 color = texture2D(sTexture, vTextureCoord);
   vec4 outColor = vec4(color.r * uKernel[0] + color.g * uKernel[1] + color.b * uKernel[2] + uColorEnhance,
    color.r * uKernel[3] + color.g * uKernel[4] + color.b * uKernel[5] + uColorEnhance,
    color.r * uKernel[6] + color.g * uKernel[7] + color.b * uKernel[8] + uColorEnhance,
    color.a);
   gl_FragColor = mix(color, outColor, uColorMixFactor);
}
