#extension GL_OES_EGL_image_external : require
precision mediump float;
varying vec2 vTextureCoord;
uniform samplerExternalOES sTexture;

void main() {
    vec4 tc = texture2D(sTexture, vTextureCoord);

    //gamma adjust
    vec3 color = pow(tc.rgb, vec3(0.677));

    // soft light
    vec3 filt = vec3(0.984, 0.466, 0.466);

    // blend
    float luminance = dot(filt, vec3(0.2125, 0.7154, 0.0721));

    vec3 soft;
    if(luminance < 0.5)
        soft = 2. * color * filt + color * color * ( 1. - 2. * filt);
    else
        soft = 2. * color * ( 1. - filt ) + sqrt( color ) * (2. * filt - 1.);

    gl_FragColor = vec4(soft, tc.a);
}