#extension GL_OES_EGL_image_external : require
precision mediump float;
varying vec2 vTextureCoord;
uniform samplerExternalOES sTexture;

vec3 color_control(vec4 tc, float contrast, float brightness, float saturate) {
    vec3 color;

    // add saturation
    float grayColor = tc.r * 0.2125 + tc.g *0.7154 + tc.b * 0.0721;
    vec4 gray = vec4(vec3(grayColor), 1.0);
    vec4 ts = clamp(gray + saturate * (tc - gray), 0.0, 1.0);

    // add contrast
    color = (ts.rgb - vec3(0.5)) * contrast + vec3(0.5);

    // add brightness
    color = color.rgb + vec3(brightness);
    return color;
}

void main() {
    vec4 tc = texture2D(sTexture, vTextureCoord);

    vec4 color;

    // applying color matrix
    //color.r = dot(tc, vec4(1.68, -1.14, 0.0, 0.0)); original ios values
    color.r = dot(tc, vec4(1.68, -0.9, 0.0, 0.0));
    color.g = tc.g; //dot(tc, vec4(0.0, 1.0, 0.0, 0.0));
    //color.b = dot(tc, vec4(0.0, 0.0, 2.25, 0.0)); original ios values
    color.b = dot(tc, vec4(0.0, 0.0, 1.4, 0.0));
    color.a = tc.a; //dot(tc, vec4(0.0, 0.0, 0.0, 1.0));

    // color control
    //color_control(color, 1.39, 0.25, 0.7); original ios values
    vec3 cc = color_control(color, 1.39, 0.25, 0.6);

    // multiply blend
    //cc = vec3(cc.r * 0.949, cc.g * 0.854, cc.b * 0.725); original ios values

    gl_FragColor = vec4(cc.r, cc.g, cc.b, color.a);

}